package data

import (
	"fmt"
	"net/http"

	"context"
)

type key int

// dKey is key for access to response data in context
const dKey key = 0

// GetAllData  return response's data
func GetAllData(r *http.Request) map[string]interface{} {
	data := GetData(r, "data")
	if data == nil {
		data = make(map[string]interface{})
	}
	mapData, ok := data.(map[string]interface{})
	if !ok {
		fmt.Printf("something wrong with data")
	}
	// log.Printf("got all data %+v", mapData)
	return mapData
}

// SetData sets some response's data for access in template
func SetData(r *http.Request, key string, val interface{}) {
	allData := GetAllData(r)
	allData[key] = val

	ctx := context.WithValue(r.Context(), "data", allData)
	*r = *r.WithContext(ctx)
	allData = GetAllData(r)
}

// GetData gets some response's data for access in template
func GetData(r *http.Request, key string) interface{} {
	return r.Context().Value(key)
}
