import React from 'react'
import axios from 'axios'
import store from '../store'

export default class UserLoginForm extends React.Component {
  constructor(props) {
    super(props);
    this.handleSubmit = this.handleSubmit.bind(this);
  }
  handleSubmit(e) {
    e.preventDefault();
    if (this.props.userStore.userLoading) {
      return;
    }
    const username = this.refs.username.value;
    const password = this.refs.password.value;
    store.dispatch({
      type: "USER_LOGIN",
      payload: axios.post(
        '/users/login',
        {
          username: username,
          password: password,
        },
      )
    })
  }
  render() {
    return (
        <div className="container">
          <div className="content-fluid">
            <div className="col-md-6 col-md-offset-3 col-xs-12">
              <h2>Log in</h2>
              <hr/>
              <form ref="loginForm" className="form-horizontal" onSubmit={(e) => this.handleSubmit(e)}>
                <div>
                  <label htmlFor="user_email">Username</label>
                  <br/>
                  <input className="form-control" type="username" ref="username"/>
                  <p></p>
                </div>
                <div>
                  <label htmlFor="user_password">Password</label>
                  <br/>
                  <input className="form-control" type="password" ref="password"/>
                  <p></p>
                </div>
                <div>
                  {this.props.userStore.userLoading &&
                    <button className="btn btn-primary pull-right">
                      <i className="fa fa-spinner fa-spin"></i>
                    </button>
                  }
                  {this.props.userStore.userLoading ||
                    <input className="btn btn-primary pull-right" type="submit" value="Log in"/>
                  }
                  <br/>
                </div>
              </form>
            </div>
          </div>
        </div>
        );
  }
}
